package edu.cmu.paid.learning.logger.stub;
import edu.cmu.paid.learning.*;
import edu.cmu.paid.learning.logger.*;
import edu.cmu.paid.database.storage.*;
//import edu.cmu.paid.database.datamodel.*;
import edu.cmu.paid.database.datamodel.AccessLogData;
import edu.cmu.paid.learning.dataminer.*;
import edu.cmu.paid.learning.dataminer.developer.BehaviorModel;
import java.util.*;

class BLTester {

  public static void main(String argv[]) {
    /* the magic line! */
    BLOBDBLogger bl = new BLOBDBLogger(new FileSubsystemStorage("/tmp/jmhsieh"));
    /* ** */
    bl = (BLOBDBLogger)buildDataSet(bl);

    DataMiner dataMiner = new DataMiner();
    Hashtable training = bl.retrieveTrainingData(LearningController.STORAGEMODEL);
    BehaviorModel model = dataMiner.developModel(training);				
       
    bl.storeModel(LearningController.STORAGEMODEL, model);
    System.out.println("Writing Model: "+model );
    
    model = null;
      System.out.println("Model = " + model);
      
      model = bl.retrieveModel(LearningController.STORAGEMODEL);
      System.out.println("Reread Model = " + model);

  }

  static BLOBDBLogger buildDataSet(BLOBDBLogger bl)  {

    Vector log = new Vector();

    ((edu.cmu.paid.learning.logger.BLOBDBLogger)bl).setObject(BLOBDBLogger.ACCESS_LOG, log);
    
    bl.storeLog(new AccessLogData("mclass"));
    bl.storeLog(new AccessLogData("bclass"));
    bl.storeLog(new AccessLogData("aclass"));
    
    log = bl.retrieveLog(LearningController.STORAGEMODEL);
    System.out.println(log);
    System.out.println("metadata /// "+bl.retrieveMetaData(LearningController.STORAGEMODEL));


    Vector log2 = bl.retrieveLog(LearningController.UPDATEMODEL);
    System.out.println(log2);
    System.out.println("metadata /// "+bl.retrieveMetaData(LearningController.UPDATEMODEL));
    return bl;
  }

  static AccessLogData addLog(String s) {
    return new AccessLogData(s);
    
  }

  
}
